#define com_maroontress_libcgi_db_BoxKit_IMPORT
#define std_util_ArraySet_IMPORT

#include <stdlib.h>
#include <stdio.h>
#include <com/maroontress/libcgi/db/BoxKit.h>
#include <std/util/ArraySet.h>
#include "Platform.h"
#include "PlatformList.h"

struct PlatformList {
    union ArraySet set;
};

static int
initialize(struct PlatformList *ls, struct BoxKit *kit)
{
    int k, platforms;
    struct Platform *p;

    if ((ls->set = ArraySet_create()).impl == NULL)
	return -1;
    if (BoxKit_getInt(kit, "platforms", &platforms) < 0)
	return -1;
    for (k = 0; k < platforms; ++k) {
	if ((p = Platform_createWithBoxKit(kit, k)) == NULL)
	    return -1;
	if (ArraySet_add(ls->set, p) < 0) {
	    Platform_free(p);
	    return -1;
	}
    }
    return 0;
}

struct PlatformList *
PlatformList_create(struct BoxKit *kit)
{
    struct PlatformList *ls;

    if ((ls = (struct PlatformList *)malloc(sizeof(*ls))) == NULL)
	return NULL;
    ls->set.impl = NULL;

    if (initialize(ls, kit) < 0) {
	PlatformList_free(ls);
	return NULL;
    }
    return ls;
}

void
PlatformList_free(struct PlatformList *ls)
{
    unsigned int k, n;

    if (ls == NULL)
	return;    
    if (ls->set.impl != NULL) {
	n = PlatformList_getPlatformSize(ls);
	for (k = 0; k < n; ++k) {
	    Platform_free(PlatformList_getPlatform(ls, k));
	}
	ArraySet_free(ls->set);
    }
    free(ls);
}

unsigned int
PlatformList_getPlatformSize(struct PlatformList *ls)
{
    return ArraySet_getSize(ls->set);
}

struct Platform *
PlatformList_getPlatform(struct PlatformList *ls, unsigned int k)
{
    return (struct Platform *)ArraySet_get(ls->set, k);
}
